<?php

namespace Drupal\tapin;

use Drupal\Core\Entity\EntityTypeManagerInterface;

/**
 * Class tapinService.
 */
class tapinService implements tapinServiceInterface {

  /**
   * Drupal\Core\Entity\EntityTypeManagerInterface definition.
   *
   * @var \Drupal\Core\Entity\EntityTypeManagerInterface
   */
  protected $entityTypeManager;

  /**
   * Constructs a new tapinService object.
   */
  public function __construct(EntityTypeManagerInterface $entity_type_manager) {
    $this->entityTypeManager = $entity_type_manager;
  }

  /**
   * @return array
   * @throws \Drupal\Component\Plugin\Exception\InvalidPluginDefinitionException
   * @throws \Drupal\Component\Plugin\Exception\PluginNotFoundException
   */
  public function getOrder() {
    $query = $this->entityTypeManager->getStorage('commerce_order')->getQuery();
    $query->condition('state', 'completed');
    // or condition
    //    $or = $query->orConditionGroup();
    //    $or->condition('field_tapin_check', NULL, 'IS NULL');
    //    $or->condition('field_tapin_check', 0);
    //    $query->condition('field_tapin_check', NULL, 'IS NULL');
    //    $query->condition('field_tapin_check', 0);

    $ids = $query->execute();
    $order = $this->entityTypeManager->getStorage('commerce_order')
      ->loadMultiple($ids);
    // get order id
    $getOrder = [];
    foreach ($order as $key => $value) {
      // get field_tapin_check value
      $tapin_check = $value->get('field_tapin_check')->getValue();
      if (empty($tapin_check) || $tapin_check[0]['value'] == 0) {


        $getProfile = $this->entityTypeManager->getStorage('profile')
          ->load($value->get('billing_profile')->target_id);
        $profile = [];
        foreach ($getProfile->get('address')->getValue() as $key1 => $value1) {

          $profile[] = [
            'country_code' => $value1['country_code'],
            'first_name' => $value1['given_name'],
            'last_name' => $value1['family_name'],
            'address' => $value1['address_line1'],
            'city' => $value1['locality'],
            'state' => $value1['administrative_area'],
            'zip' => $value1['postal_code'],
            'country' => $value1['country_code'],
            'postal_code' => $value1['postal_code'],
            'Province' => $value1['administrative_area'],
          ];

        }
        $orderItem = $this->entityTypeManager->getStorage('commerce_order_item')
          ->load($value->get('order_items')->getValue()[0]['target_id']);
        $prodoct = [
          'product_id' => $orderItem->get('purchased_entity')
            ->getValue()[0]['target_id'],
          'quantity' => $orderItem->get('quantity')->getValue()[0]['value'],
          'title' => $orderItem->get('title')->getValue()[0]['value'],
        ];

        $getOrder[] = [
          'order_id' => $value->id(),
          'order_owner' => $value->get('uid')->target_id,
          'order_number' => $value->getOrderNumber(),
          'order_total' => $value->getTotalPrice()->getNumber() / 1,
          'order_date' => $value->getPlacedTime(),
          'profile' => $profile,
          'product' => $prodoct,
        ];
      }
    }
    return $getOrder;
  }

  /**
   * @param $uid
   *
   * @return mixed
   * @throws \Drupal\Component\Plugin\Exception\InvalidPluginDefinitionException
   * @throws \Drupal\Component\Plugin\Exception\PluginNotFoundException
   */
  public function getUserName($uid) {
    //get user name
    $user = $this->entityTypeManager->getStorage('user')
      ->load($uid);
    return $user->get('name')->value;
  }

  /**
   * @param $data
   *
   * @return bool
   * @throws \Drupal\Component\Plugin\Exception\InvalidPluginDefinitionException
   * @throws \Drupal\Component\Plugin\Exception\PluginNotFoundException
   * @throws \Drupal\Core\Entity\EntityStorageException
   */
  public function updateOrder($data) {
    // update order
    $order = $this->entityTypeManager->getStorage('commerce_order')
      ->load($data['order_id']);
    $order->set('field_barcode_tapin', $data['barcode']);
    $order->set('field_tapin_check', 1);
    $order->set('field_tapin_order_id', $data['field_tapin_order_id']);
    $order->save();
    return TRUE;
  }

}
